%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Beamer Presentation
% LaTeX Template
% Version 1.0 (10/11/12)
%
% This template has been downloaded from:
% http://www.LaTeXTemplates.com
%
% License:
% CC BY-NC-SA 3.0 (http://creativecommons.org/licenses/by-nc-sa/3.0/)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%----------------------------------------------------------------------------------------
%	PACKAGES AND THEMES
%----------------------------------------------------------------------------------------

\documentclass{beamer}

\mode<presentation> {

% The Beamer class comes with a number of default slide themes
% which change the colors and layouts of slides. Below this is a list
% of all the themes, uncomment each in turn to see what they look like.

% \usetheme{default}
% \usetheme{AnnArbor}
% \usetheme{Antibes}
%\usetheme{Bergen}
% \usetheme{Berkeley}
% \usetheme{Berlin}
% \usetheme{Boadilla}
% \usetheme{CambridgeUS}
% \usetheme{Copenhagen}
% \usetheme{Darmstadt}
% \usetheme{Dresden}
% \usetheme{Frankfurt}
%\usetheme{Goettingen}
%\usetheme{Hannover}
%\usetheme{Ilmenau}
%\usetheme{JuanLesPins}
%\usetheme{Luebeck}
% \usetheme{Madrid}
%\usetheme{Malmoe}
%\usetheme{Marburg}
%\usetheme{Montpellier}
% \usetheme{PaloAlto}
% \usetheme{Pittsburgh}
% \usetheme{Rochester}
% \usetheme{Singapore}
% \usetheme{Szeged}
\usetheme{Warsaw}

% As well as themes, the Beamer class has a number of color themes
% for any slide theme. Uncomment each of these in turn to see how it
% changes the colors of your current slide theme.

% \usecolortheme{albatross}
\usecolortheme{beaver}
% \usecolortheme{beetle}
% \usecolortheme{crane}
% \usecolortheme{dolphin}
% \usecolortheme{dove}
% \usecolortheme{fly}
% \usecolortheme{lily}
% \usecolortheme{orchid}
% % \usecolortheme{rose}
% \usecolortheme{seagull}
% \usecolortheme{seahorse}
% \usecolortheme{whale}
% \usecolortheme{wolverine}

%\setbeamertemplate{footline} % To remove the footer line in all slides uncomment this line
\setbeamertemplate{footline}[page number] % To replace the footer line in all slides with a simple slide count uncomment this line

\setbeamertemplate{navigation symbols}{} % To remove the navigation symbols from the bottom of all slides uncomment this line
}

\usepackage{graphicx} % Allows including images
\usepackage{booktabs} % Allows the use of \toprule, \midrule and \bottomrule in tables
\usepackage[spanish]{babel}
\usepackage[utf8]{inputenc}
\usepackage{upgreek}
\usepackage{ dsfont }

\usepackage{listings}
\definecolor{codegreen}{rgb}{0,0.6,0}
\definecolor{codegray}{rgb}{0.5,0.5,0.5}
\definecolor{codepurple}{rgb}{0.58,0,0.82}
\definecolor{codepurple}{rgb}{0.1, 1.0, 1.0}
\definecolor{backcolour}{rgb}{0.95,0.95,0.92}
 
\lstdefinestyle{mystyle}{
    backgroundcolor=\color{backcolour},   
    commentstyle=\color{codegreen},
    keywordstyle=\color{magenta},
    numberstyle=\tiny\color{codegray},
    stringstyle=\color{codepurple},
    basicstyle=\footnotesize,
    breakatwhitespace=false,         
    breaklines=true,                 
    captionpos=b,                    
    keepspaces=true,                 
    numbers=left,                    
    numbersep=5pt,                  
    showspaces=false,                
    showstringspaces=false,
    showtabs=false,                  
    tabsize=2
}
\lstset{style=mystyle}


%----------------------------------------------------------------------------------------
%	TITLE PAGE
%----------------------------------------------------------------------------------------

\title[Short title]{Automatas Finito No Deterministas y Expresiones Regulares} % The short title appears at the bottom of every slide, the full title is only on the title page

\author{Camilo Rojas Milla} % Your name
\institute[] % Your institution as it will appear on the bottom of every slide, may be shorthand to save space
{
% University of California \\ % Your institution for the title page
\medskip
\textit{camrojas@uchile.cl} % Your email address
}
\date{\today} % Date, can be changed to a custom date

\begin{document}

\begin{frame}
\titlepage % Print the title page as the first slide
\end{frame}

\begin{frame}
\frametitle{Resumen} % Table of contents slide, comment this block out to remove it
\tableofcontents % Throughout your presentation, if you choose to use \section{} and \subsection{} commands, these will automatically be printed on this slide as an overview of your presentation
\end{frame}

%----------------------------------------------------------------------------------------
%	PRESENTATION SLIDES
%----------------------------------------------------------------------------------------

%------------------------------------------------
\section{Repaso} % Sections can be created in order to organize your presentation into discrete blocks, all sections and subsections are automatically printed in the table of contents as an overview of the talk
%------------------------------------------------

\subsection{Repaso AFD} % A subsection can be created just before a set of slides with a common theme to further break down your presentation into chunks

\begin{frame}
\frametitle{Repaso AFD}

 Un Autómata Finito Determinista ({\bf AFD}) es una tupla $A = (Q, \Sigma, \delta, q_0, F)$ donde:
 \begin{itemize}
  \item $Q = \{q_0, q_1 \ldots q_n\}$ es el conjunto de estados.
  \item $\Sigma$ es el alfabeto.
  \item $\delta$ es la función de transiciones.
  \item $q_0$ el estado inicial.
  \item $F$ el conjunto de los estados finales.
 \end{itemize}

 
 $Q$ es finito no vacío, $q_0 \in Q$, $F \subseteq  Q$ y 
 
 $$\delta : Q \times \Sigma \rightarrow Q$$

\end{frame}

\begin{frame}
\frametitle{Repaso AFD}
{\bf Relación Binaria}

$$(q, a \omega) \vdash_A (p, \omega) \Leftrightarrow \delta(q, a) = p$$

Con $a \in \Sigma$ y $\omega \in \Sigma^*$.

\vspace{0.3cm}
{\bf Clausura Refleja}

$\vdash_A^*$ :saltarse varios pasos de $\vdash_A$.

$\omega$ es aceptado por el autómata $\Rightarrow$ $(q_0, \omega)\vdash_A^*(p,\upvarepsilon)$ donde $p \in F$

\vspace{0.3cm}
{\bf Lenguaje Regular }

Un lenguaje es {\bf regular }si existe un {\bf AFD} talque $$L=L(A)$$
\end{frame}

\subsection{Repaso AFND}
\begin{frame}
 \frametitle{Repaso AFND}
 Un Autómata Finito No Determinista ({\bf AFND}) es una tupla $A = (Q, \Sigma, \delta, q_0, F)$ donde:
 \begin{itemize}
  \item $Q = \{q_0, q_1 \ldots q_n\}$ es el conjunto de estados.
  \item $\Sigma$ es el alfabeto.
  \item $\delta$ es la función de transiciones.
  \item $q_0$ el estado inicial.
  \item $F$ el conjunto de los estados finales.
 \end{itemize}

 $$\delta : Q \times \Sigma \rightarrow 2^Q$$
$$2^Q = \{ A | A \subseteq Q\}$$
\end{frame}

\begin{frame}
  \frametitle{Repaso AFND}
  
Sea $A = (Q, \Sigma, \delta, q_0, F)$ un AFND, entonces:
    
{\bf Relacion Binaria}    
$$(q, a\omega)\vdash_A (p, \omega) \Leftrightarrow p \in \delta(q, a)$$


$\omega$ es aceptado por A si existe $p$ tq:

{\bf Clausura refleja}  
$$(q_0, \omega)\vdash_A^*(p, \upvarepsilon), p \in F$$ 


Un lenguaje definido por A sera un conjunto de palabras tal que:

{\bf Lenguaje Regular}
$$L(A) = \{ \omega \in \Sigma^* | \exists p \in F \text{ tq } (q_0, \omega) \vdash_A^* (p, \upvarepsilon) \}$$
\end{frame}

\subsection{Notaciones}
\begin{frame}
 \frametitle{Notaciones y reglas AFD}
 Si estas en un estado $p$ y ves un símbolo $c$ las siguientes cosas pueden pasar:
 \begin{enumerate}
  \item Puedes consumir el símbolo y cambiar a un estado $q$
  \item Puede no haber una transición definida para $(p, c)$ en cuyo caso el AFD para (halt) y rechazara el string.
  \item Si después de haber leído todos los caracteres el AFD esta en un estado terminal, aceptara el string.
 \end{enumerate}
 
\end{frame}

\begin{frame}
 \frametitle{Notaciones y reglas AFND}
  Si estas en un estado $p$ y ves un símbolo $c$ las siguientes cosas pueden pasar:
  \begin{enumerate}
   \item Puedes consumir el símbolo y cambiar a algún estado que este en $\delta(p, c)$
   \item En el caso de $AFND\text{-}\upvarepsilon$ si existe una transición con $\upvarepsilon$ puedes no consumir el símbolo y pasar a un estado en $\delta(p, \upvarepsilon)$
   \item Como el AFD puede que no existe una transición $\delta(p, c)$ o $\delta(p, \upvarepsilon)$ en cuyo caso el AFND para (halt) y rechazara el string.
   \item Si existe un camino que lleve al AFND a un estado terminal luego de consumir todos los símbolos, diremos que el string es aceptado.
  \end{enumerate}
\end{frame}

\begin{frame}
 \frametitle{Determinación de un AFND-$\upvarepsilon$ }
 \begin{enumerate}
  \item Construir una tabla con columnas una por cada símbolo en $\Sigma$. 
 \item En la primera fila escribir el inicial $\{q0\}$ y  todos los estados a los que puedo llegar desde q0 con $\upvarepsilon$. 
 \item En la primera fila, en la columna con símbolo $c$ escribir todos los estados a los que puedo llegar desde el primer estado, con entrada $c$ o $\upvarepsilon$ . 
 \item Copiar las casillas de la fila anterior como principio de nuevas filas. 
 \item Para cada fila R pendiente, rellenar la fila R escribiendo en cada columna todos los estados a los que puedo llegar desde algún estado de R con entrada $c$ o $\upvarepsilon$. 
 \item Copiar las casillas de la fila anterior como principio de nuevas filas.
 \item Repetir los pasos 5 y 6 hasta que no queden filas por rellenar.
 \end{enumerate}
\end{frame}

\begin{frame}
 \frametitle{Determinación de un AFND-$\upvarepsilon$}
 Determinar el siguiente AFND-$\upvarepsilon$
   \begin{figure}
   \includegraphics[width=0.5\linewidth]{afnde1.png}
 \end{figure}
\end{frame}

\begin{frame}
 \frametitle{Determinación de un AFND-$\upvarepsilon$}
Resultado:
   \begin{figure}
   \includegraphics[width=0.6\linewidth]{resafd.png}
   \includegraphics[width=0.3\linewidth]{tabla.png}
 \end{figure}
\end{frame}

\section{Ejercicios}

\subsection{Ejercicio 1}
\begin{frame}
\frametitle{Ejercicio 1}
\begin{itemize}
 \item Diseñe un AFND que acepte los Strings que sean una concatenación de 'aba' o 'ba', con $\Sigma=\{a,b\}$.
 \item Determine el AFND que diseño
 \item Escriba la ER asociada.
\end{itemize}
\end{frame}
% 
\subsection{Ejercicio 2}
\begin{frame}
\frametitle{Ejercicio 2}
Determine el AFND de la figura

\begin{figure}
   \includegraphics[width=0.5\linewidth]{afnd1.png}
\end{figure}

\end{frame}
% 
\subsection{Ejercicio 3}
\begin{frame}
\frametitle{Ejercicio 3}
Determine el AFND de la figura

\begin{figure}
   \includegraphics[width=0.7\linewidth]{afnd2.png}
\end{figure}
 
\end{frame}
% 
\subsection{Ejercicio 4}
\begin{frame}
\frametitle{Ejercicio 4}

Determine el AFND de la figura

\begin{figure}
   \includegraphics[width=0.7\linewidth]{afnd3.png}
\end{figure}
 
\end{frame}

\begin{frame}
\Huge{\centerline{FIN}}
\end{frame}

%----------------------------------------------------------------------------------------

\end{document} 
